close all
clear all
clc
format long

%%% =======================================================================
%% Input
%%% =======================================================================
folder = 'C:\Users\erinb\Documents\NTNU\Teaching\EWEM_H14\ProjectDescription\xxSRA_models\OC4semi\Decay6'; % folder 
% where the analysis was carried out
bodyNum = 1; % body number
motion = 6; %1 for surge, 3 for heave, 5 for pitch, 6 for yaw
FFT_tmax = 1000; % maximum time for the FFT plot 
%(reduce if motions have already died out) 
endRamp = 360; % start time for decay test
matfileName = 'm001.m';
wnForDampCoeff = 2*pi/80.4; % natural frequency in rad/s for damping coefficient 
% calculation. The damping coefficient calculation will not run for 
% wnForDampCoeff=0. This should be updated.  

%% read results files
currentFolder = pwd; 
cd(folder)
fid = fopen(matfileName);
data = textscan(fid,'%s',12,'Delimiter','\n');
data = data{1};

for ii = 1:length(data)
   eval(data{ii}) ;
end

B = bodyNum;
R = 29;

for kk = 1:6
    load(['B0' num2str(B) 'r' num2str(R) 'c00' num2str(kk)  ])
end
cd(currentFolder)
%%

t = Time';
eval( ['v = B0' num2str(B) 'r' num2str(R) 'c00' num2str(motion)  ';']);
dt = t(2)-t(1);

%  only consider time greater than 200 s
% this line can cause some problems! may need to modify
skippt = sum(t<endRamp);
endpt = sum(t<FFT_tmax);
[tp ind] = dat2tp([t(skippt:endpt) v(skippt:endpt)],0,'none');
% estimate the period based on the peaks and troughs
TT = 2*mean(tp(2:end-2,1)-tp(1:end-3,1))
wnHz = 1/TT

% Plot the time series and the peaks/troughs
f= figure;
set(f,'Position',[100 100 700 200])
plot(t,v)
hold on
plot(tp(1:end-1,1),tp(1:end-1,2),'k.')
xlabel('Time, s')

% compute the damping coefficients
if wnForDampCoeff~=0
    [b1,b2] = damp_coeff(tp,t,v,wnForDampCoeff,FFT_tmax,endRamp)
else
    'Computation of damping coefficients was not performed'
end

endt = round(FFT_tmax/dt);
Fs = 1/dt;                    % Sampling frequency
T = 1/Fs;                     % Sample time
L = length(t(skippt:endt));                     % Length of signal
t = t(skippt:endt);                % Time vector
NFFT = 2^nextpow2(L); % Next power of 2 from length of y
Y = fft(v(skippt:endt),NFFT)/L;
f = Fs/2*linspace(0,1,NFFT/2+1);

% Plot single-sided amplitude spectrum.
figure
plot(f,2*abs(Y(1:NFFT/2+1))) 
%title('Single-Sided Amplitude Spectrum of y(t)')
xlabel('Frequency (Hz)')
ylabel('|F|')
xlim([0 3])    
    
fclose all;



